#define WIN32_LEAN_AND_MEAN
#include <Windows.h>

#include <cstdint>

#include <string>
#include <map>
#include <unordered_map>

struct patch_set {
	uintptr_t fps;
	uintptr_t fps_half;
	uintptr_t effect_speed;
};

std::unordered_map<std::string, std::map<DWORD, patch_set>> patches =
{
	// RA3 1.12
	{
		"||VER1|512|CONFIG=Release|DATE=2009-07-07|EXENAME=rts-final.exe|GUID=12816796-F70F-4cfd-8994-6117E7BA1266|ID=C&C3|MACHINE=EALA-BUILD20|TIME=14:21:00|USER=codebuilder|VERSION=1.12.3444.25830|",
		{
			{
				0x50185C01,
				{
					.fps = 0xCB409C,
					.fps_half = 0xCB4098,
					.effect_speed = 0x4D7BD6 + 2,
				}
			},
			{
				0x4A53BB67,
				{
					.fps = 0xCAF9D4,
					.fps_half = 0xCAF9D0,
					.effect_speed = 0x99E506 + 2,
				}
			},
		},
	},

	// RA3 Uprising
	{
		"||VER1|512|CONFIG=Release|DATE=2009-02-26|EXENAME=rts-final.exe|GUID=0364FDB7-F6E0-43c2-B87C-BB428A33ABDF|ID=C&C3|MACHINE=EALA-BUILD113|TIME=21:20:01|USER=codebuilder|VERSION=1.0.3313.38400|",
		{
			{
				0x49A7778C,
				{
					.fps = 0xCC3A9C,
					.fps_half = 0xCC3A98,
					.effect_speed = 0x9B1FD6 + 2,
				}
			}
		}
	}
};

uint32_t target_fps;
uint32_t target_fps_half;
float scale_effect;

void patch(uintptr_t addr, auto value)
{
	if (!addr) return;

	DWORD old_protect;
	VirtualProtect(reinterpret_cast<void*>(addr), sizeof(value), PAGE_EXECUTE_READWRITE, &old_protect);
	memcpy(reinterpret_cast<void*>(addr), reinterpret_cast<const void*>(&value), sizeof(value));
	VirtualProtect(reinterpret_cast<void*>(addr), sizeof(value), old_protect, &old_protect);
}

void apply_patch(patch_set& p)
{
	target_fps = GetPrivateProfileInt(L"graphics", L"fps", 60, L".\\sage.ini");
	target_fps_half = target_fps / 2;
	scale_effect = GetPrivateProfileInt(L"graphics", L"effect_speed", 200, L".\\sage.ini") / 100000.f;

	patch(p.fps, target_fps);
	patch(p.fps_half, target_fps_half);
	patch(p.effect_speed, &scale_effect);
}

BOOL WINAPI DllMain(
	HINSTANCE instance,
	DWORD reason,
	LPVOID _)
{
	if (reason != DLL_PROCESS_ATTACH) {
		return true;
	}

	const auto base = reinterpret_cast<uintptr_t>(GetModuleHandle(nullptr));
	const auto* dos_header = reinterpret_cast<PIMAGE_DOS_HEADER>(base);
	const auto* pe_header = reinterpret_cast<PIMAGE_NT_HEADERS>(base + dos_header->e_lfanew);
	const char* rts_ver = nullptr;

	for (size_t i = 0; i < pe_header->FileHeader.NumberOfSections; i++)
	{
		const auto* section = IMAGE_FIRST_SECTION(pe_header) + i;

		if (memcmp("rts.ver", section->Name, 8)) {
			continue;
		}

		rts_ver = reinterpret_cast<const char*>(base + section->VirtualAddress);
		break;
	}

	if (!rts_ver)
	{
		MessageBox(nullptr, L"⵽ SAGE Ϸ", L"", MB_OK | MB_ICONERROR);
		ExitProcess(-1);
	}

	auto game = patches.find(rts_ver);

	if (game == patches.end())
	{
		char output[1024];
		sprintf_s(output, 1024, "⵽ֵ֧Ϸ\n\nϷ: \n%s", rts_ver);

		MessageBoxA(nullptr, output, "", MB_OK | MB_ICONERROR);
		ExitProcess(-2);
	}

	auto timestamp = pe_header->FileHeader.TimeDateStamp;
	auto patch = game->second.find(timestamp);

	if (patch == game->second.end())
	{
		char output[1024];
		sprintf_s(output, 1024, "δҵ˶ļӦĲ\n\nTIMESTAMP: %X\nRTS VERSION:%s", timestamp, rts_ver);

		MessageBoxA(nullptr, output, "", MB_OK | MB_ICONERROR);
		ExitProcess(-3);
	}

	apply_patch(patch->second);

	return true;
}